Attribute VB_Name = "FPAPI"

'
'       fpapi.bas
'
'               FinePrint API main header file
'
'               Copyright (c) 1999-2000 FinePrint Software
'               All Rights Reserved.
'

' opaque handles into FinePrint API
Global HFinePrint As Long               ' session handle from fpOpen
Global HFpStat As Long                  ' stationery handle from fpCreateStationery

' job count structure
Type FpJobCount
        cJobsPending As Long            ' number of print jobs queued in the Dispatcher
        cJobsDeferred As Long           ' number of print jobs queued in the FinePrint UI
        cJobsCumulative As Long         ' cumulative number of print jobs handled since Dispatcher startup
End Type

' job status structure
Type FpJobStatus
        fAppTerm As Long             ' =1 if the printing app has terminated
        fJobStarted As Long          ' =1 if the print job started (StartDoc)
        fJobCompleted As Long        ' =1 if the print job completed (EndDoc)
        fTimeout As Long             ' =1 if we timed out waiting for the job
End Type

' function prototypes
Public Declare Function fpClose Lib "FPAPI4A.DLL" Alias "fpClose" (ByVal hfp As Long, ByVal fDeleteJobs As Long) As FpError
Public Declare Function fpCloseStationery Lib "FPAPI4A.DLL" (ByVal hfp As Long, ByVal hStat As Long) As FpError
Public Declare Function fpCreateStationery Lib "FPAPI4A.DLL" (ByVal hfp As Long, ByVal pszStat As String, phStat As Long) As FpError
Public Declare Function fpDeleteStationery Lib "FPAPI4A.DLL" (ByVal hfp As Long, ByVal pszStat As String) As FpError
Public Declare Function fpDisplayDialog Lib "FPAPI4A.DLL" (ByVal hfp As Long, pdwDlg As Long) As FpError
Public Declare Function fpGetFinePrinterName Lib "FPAPI4A.DLL" (ByVal iPrinter As Integer, ByVal pszFinePrinter As String) As FpError
Public Declare Function fpGetJobCount Lib "FPAPI4A.DLL" (ByVal hfp As Long, pjc As FpJobCount) As FpError
Public Declare Function fpGetLayoutAttr Lib "FPAPI4A.DLL" (ByVal hfp As Long, ByVal li As eLayoutItem, pAttr As Any, ByVal cbAttr As Long) As Long
Public Declare Function fpGetStationeryAttr Lib "FPAPI4A.DLL" (ByVal hfp As Long, ByVal hStat As Long, ByVal si As eStatItem, ByVal sia As eStatItemAttr, pAttr As Any, ByVal cbAttr As Long) As Long
Public Declare Function fpGetVersion Lib "FPAPI4A.DLL" () As Long
Public Declare Function fpGetVersionReq Lib "FPAPI4A.DLL" () As Long
Public Declare Function fpOpen Lib "FPAPI4A.DLL" (ByVal pszFinePrinter As String, phfp As Long) As FpError
Public Declare Function fpOpenStationery Lib "FPAPI4A.DLL" (ByVal hfp As Long, ByVal pszStat As String, phStat As Long) As FpError
Public Declare Function fpPrintAllJobs Lib "FPAPI4A.DLL" (ByVal hfp As Long, ByVal pszOutputFile As String, ByVal fShowProgress As Long, ByVal fDeleteJobsWhenDone As Long) As FpError
Public Declare Function fpSaveSettings Lib "FPAPI4A.DLL" (ByVal hfp As Long) As FpError
Public Declare Function fpSetDeferAll Lib "FPAPI4A.DLL" (ByVal hfp As Long, ByVal fDeferAll As Long) As FpError
Public Declare Function fpSetDestPrinterAttr Lib "FPAPI4A.DLL" (ByVal hfp As Long, ByVal pszDestPrinter As String, ByVal pszSetting As String, ByVal dwValue As Long) As FpError
Public Declare Function fpSetLayoutAttr Lib "FPAPI4A.DLL" (ByVal hfp As Long, ByVal li As eLayoutItem, pAttr As Any) As FpError
Public Declare Function fpSetShowDlg Lib "FPAPI4A.DLL" (ByVal hfp As Long, ByVal dwShowDlg As Long) As FpError
Public Declare Function fpSetStationeryAttr Lib "FPAPI4A.DLL" (ByVal hfp As Long, ByVal hStat As Long, ByVal si As eStatItem, ByVal sia As eStatItemAttr, pAttr As Any) As FpError
Public Declare Function fpWaitForJob Lib "FPAPI4A.DLL" (ByVal hfp As Long, pjcOrig As FpJobCount, ByVal hProcess As Long, ByVal cSecTimeoutStart As Long, ByVal cSecTimeoutPrint As Long, pjs As FpJobStatus) As FpError
